<?php
/**
 * @version		1.2
 * @package		Google_shopping
 * @copyright           Copyright © 2010 - All rights reserved.
 * @license		GNU/GPL
 * @author		Aurone
 * @mail                info@aurone.com
 * @website		www.aurone.com
 *
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class googleshoppingModelGoogleshopping extends Jmodel
{
	function getPath(){

		$path_array=explode('/',JURI::base());
		for($i=0;$i<(count($path_array)-2);$i++){
			$path.=$path_array[$i]."/";
		} // Return path (without administrator)
		return $path;
	}


	function getXmlProduct($opt=""){
		$dom = new DOMDocument('1.0');

		$rss = $dom->createElement("rss"); //Root element
		$rss->setAttribute("xmlns:g", "http://base.google.com/ns/1.0");
		$rss->setAttribute("version", "2.0");

		$dom->appendChild($rss);

		$config=& JFactory::getConfig();
		//Creating children elements & appending them
		$root = $dom->createElement('channel','');
		$title = $dom->createElement('title','VM Google Shopping');
		$link = $dom->createElement('link',$_SERVER["HTTP_HOST"]);
		$desc = $dom->createElement('description',$config->getValue( 'config.MetaDesc' ));
		$root->appendChild($title);
		$root->appendChild($link);
		$root->appendChild($desc);

		$res=$this->getProductPublish();

                $db = &JFactory::getDBO();

                $path=$this->getPath();

		foreach ($res as $val){
                    //Creating URL
			$link="";
			if(JRequest::getVAR("g:rewrite")=='1'){
				$query="SELECT *  FROM `#__redirection` WHERE `newurl` LIKE '%product_id=".$val->product_id."%' LIMIT 0,1";
				$db->setQuery($query);
				$result=$db->loadObjectList();
                                    if(count($result)>0){
                                    $link=$path.$result[0]->oldurl;
                                    }
                                    else{
                                    //Using simple URL if URL Rewrite is not found
                                    $link=$path.'index.php?page=shop.product_details&amp;flypage=flypage.tpl&amp;product_id=';
                                    $link.=$val->product_id;
                                    $link.="&amp;category_id=";
                                    $link.=$val->category_id;
                                    $link.="&amp;option=com_virtuemart&Itemid=30";
                                    }
			}
			else
			{
				$link=$path.'index.php?page=shop.product_details&amp;flypage=flypage.tpl&amp;product_id=';
				$link.=$val->product_id;
				$link.="&amp;category_id=";
				$link.=$val->category_id;
				$link.="&amp;option=com_virtuemart&Itemid=30";
			}
			$item= $dom->createElement('item',''); //Creatong items
			$item_id = $dom->createElement('g:id',$val->product_sku);
			$item_title = $dom->createElement('title',htmlspecialchars($val->product_name));
			$item_link = $dom->createElement('link',$link);
			if($val->product_tax_id != 0){
				$q = "SELECT * FROM #__vm_tax_rate  where tax_rate_id = ".$val->product_tax_id;
				$db->setQuery($q);
				$results=$db->loadObjectList();
				foreach($results as $row){
					$val->product_price = $val->product_price + $val->product_price * $row->tax_rate;
				}
			}
			//Calculating reduced price
			$starttime = time();
			$year = date('Y');
			$month = date('n');
			$day = date('j');
			// get the beginning time of today
			$endofday = mktime(0, 0, 0, $month, $day, $year) - 1440;
			$q = "SELECT amount,is_percent FROM #__vm_product,#__vm_product_discount ";
			$q .= "WHERE product_id='$val->product_id' AND (start_date<='$starttime' OR start_date=0) AND (end_date>='$endofday' OR end_date=0) ";
			$q .= "AND product_discount_id=discount_id";
			$db->setQuery($q);
			if($result=$db->loadObject()){

				$discount_info["amount"] = $result->amount;
				$discount_info["is_percent"] = $result->is_percent;
                $no_discount = false;
			}else {
				$discount_info["amount"] = 0;
				$discount_info["is_percent"] = 0;
                $no_discount = true;
			}
			$val->product_price  = floatVal($val->product_price);
			$discount_info["amount"] = floatVal($discount_info["amount"]);
			if (! $no_discount) {
               if($discount_info["is_percent"]==1)
               		$val->product_price =  ( $val->product_price * (1 - $discount_info["amount"] * 0.01)) ;
               else
               		$val->product_price = $val->product_price - $discount_info["amount"] ;
            }
            //Reduced price 'TTC'

			$item_price = $dom->createElement('g:price', number_format($val->product_price,2,'.','').' '.$val->product_currency );
			$item_description = $dom->createElement('description',htmlspecialchars($val->product_desc) );
			$item_condition = $dom->createElement('g:condition','new' );
			$item_avai = $dom->createElement('g:availability','in stock' );
			
			//Appending item descriptions
			$item->appendChild($item_id);
			$item->appendChild($item_title);
			$item->appendChild($item_link);
			$item->appendChild($item_price);
			$item->appendChild($item_description);
			$item->appendChild($item_condition);
			$item->appendChild($item_avai);

			if(JRequest::getVar('g:image_link')==1){
				$item_img = $dom->createElement('g:image_link',$path.'components/com_virtuemart/shop_image/product/'.$val->product_full_image );
				$item->appendChild($item_img);
			}
			if(JRequest::getVar('g:product_type')==1){
				$item_cat= $dom->createElement('g:product_type',$val->category_name );
				$item->appendChild($item_cat);
			}

			if(JRequest::getVar('g:manufacturer')==1){
				$item_man= $dom->createElement('g:brand',$val->mf_name );
				$item->appendChild($item_man);
			}

			if(JRequest::getVar('g:quantity')==1){
				$item_qtt= $dom->createElement('g:quantity',$val->product_in_stock );
				$item->appendChild($item_qtt);
			}

			if(JRequest::getVar('g:year')==1){
				$item_year= $dom->createElement('g:year',date("Y",$val->cdate) );
				$item->appendChild($item_year);
			}
			$root->appendChild($item);

		}
		$rss->appendChild($root);
                $dom->appendChild($rss);
                //Saving tmp file to send via FTP
		if($opt=='save'){
                    $dom->save(JPATH_COMPONENT.DS."exportXML".DS."VMgoogle.xml"); /*die("have a look @ ".JPATH_COMPONENT.DS."exportXML".DS."VMgoogle.xml");*/ }

		return  $dom->saveXML($dom);
	}



	function getProductPublish(){
		$db = &JFactory::getDBO();
		$sql ="SELECT p.`product_id`,p.`product_sku`, p.`product_full_image`, p.`product_in_stock`, p.`product_special`, p.`product_name`, p.`product_desc` , p.`cdate`,p.`product_tax_id`, pp.`product_price`, pp.`product_currency`,
				f.mf_name, c.category_name, c.category_id
				FROM ((((`#__vm_product` p
				INNER JOIN  `#__vm_product_price` pp ON p.`product_id` = pp.`product_id` )
				INNER JOIN  `#__vm_product_category_xref` pc ON p.`product_id` = pc.`product_id`)
				INNER JOIN  `#__vm_category` c ON pc.`category_id` = c.`category_id`)
				INNER JOIN  `#__vm_product_mf_xref` pf ON p.`product_id` = pf.`product_id`)
				INNER JOIN  `#__vm_manufacturer` f ON pf.`manufacturer_id` = f.`manufacturer_id`
				WHERE p.`product_publish`='Y'
                                GROUP BY p.`product_id` ";
		$db->setQuery($sql);
		$result=$db->loadObjectList();
		return $result;
	}

	function ftpPut($server,$login,$pwd,$remote){
			//GLOBAL $mainframe;
			// Initilizing FTP connection
			$conn_id = ftp_connect($server);

			// Loggin with FTP account
			$login_result = ftp_login($conn_id, $login, $pwd);
			$this->getXmlProduct(save);
                        $fichier=JPATH_COMPONENT.DS."exportXML".DS."VMgoogle.xml";
			// Trying to uplode the XML file
			$uploaded=ftp_put($conn_id, $remote, $fichier, FTP_BINARY, 0);
                        if ($uploaded) {
			 	$msg="<h2>".JTEXT::_('UPLOAD')."</h2>";
                        }
			else {
			 	$msg="<h2>".JTEXT::_('UPLOAD FAIL').' '.$remote." </h2> \n";
			}

			@unlink(JPATH_COMPONENT.DS."exportXML".DS."VMgoogle.xml");
			// Closing connection
			ftp_close($conn_id);
			fclose($handle);
                        //$mainframe->redirect('index.php?option=com_googleshopping',$msg);
                        return $msg;
		}

}
?>
